JEDiagnostics (Oracle - Berkeley DB Java Edition API)
Date: 2014-12-16

com.sleepycat.je.jmx

## Class JEDiagnostics

- java.lang.Object
- - com.sleepycat.je.jmx.JEMBean
  - - com.sleepycat.je.jmx.JEDiagnostics

- All Implemented Interfaces:
    com.sleepycat.je.dbi.EnvironmentImpl.MBeanRegistrar, DynamicMBean

      public class JEDiagnostics
      extends JEMBean
      implements DynamicMBean

  JEDiagnostics is a debugging mbean for a non replicated JE Environment. This is intended as a locus of field support functionality. While it may be used by the application developer, the primary use case is for a support situation. Currently much of this functionality is also available through the standard java.util.logging MBean.

  It is a concrete MBean created by registering a JE Environment as an MBean through setting the JEDiagnostics system property. It only works on an active JE Environment, and one Environment can only have one JEDiagnostics instance. There are two attributes and one operation:

  Attributes:

  - consoleHandlerLevel: which sets the console handler level.
  - fileHandlerLevel: which sets the file handler level.
  Operations:
  - resetLoggingLevel: which sets the level for the current loggers in the LogManager.

  We can use these attributes and operations to dynamically change the logging level for debugging purposes.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static MBeanAttributeInfo` | `ATT_CONSOLEHANDLER_LEVEL`
    `protected static MBeanAttributeInfo` | `ATT_FILEHANDLER_LEVEL`
    `protected static String` | `CONSOLEHANDLER_LEVEL`
    `protected static String` | `FILEHANDLER_LEVEL`
    `protected static String` | `OP_RESET_LOGGING`
    `protected static MBeanOperationInfo` | `OP_RESET_LOGGING_LEVEL`
    `protected static MBeanParameterInfo[]` | `resetLoggingParams`

    - ### Fields inherited from class com.sleepycat.je.jmx.JEMBean

      `className, currentClass, DESCRIPTION, env, jeName, operationList, server, statParams`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `JEDiagnostics()`
    `protected` | `JEDiagnostics(Environment env)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addOperations()` Add MBean operations into the list.
    `protected void` | `doRegisterMBean(Environment env)`
    `Object` | `getAttribute(String attributeName)`
    `protected MBeanAttributeInfo[]` | `getAttributeList()` Get attribute metadata for this MBean.
    `AttributeList` | `getAttributes(String[] attributes)`
    `protected void` | `initClassFields()`
    `Object` | `invoke(String actionName, Object[] params, String[] signature)`
    `void` | `setAttribute(Attribute attribute)`
    `AttributeList` | `setAttributes(AttributeList attributes)`

    - ### Methods inherited from class com.sleepycat.je.jmx.JEMBean

      `doRegister, doUnregister, getConstructors, getMBeanInfo, getNotificationInfo, getStatsConfig, resetMBeanInfo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.management.DynamicMBean

      `getMBeanInfo`

- - ### Field Detail

    - #### CONSOLEHANDLER_LEVEL

          protected static final String CONSOLEHANDLER_LEVEL

      See Also:
        Constant Field Values

    - #### FILEHANDLER_LEVEL

          protected static final String FILEHANDLER_LEVEL

      See Also:
        Constant Field Values

    - #### ATT_CONSOLEHANDLER_LEVEL

          protected static final MBeanAttributeInfo ATT_CONSOLEHANDLER_LEVEL

    - #### ATT_FILEHANDLER_LEVEL

          protected static final MBeanAttributeInfo ATT_FILEHANDLER_LEVEL

    - #### OP_RESET_LOGGING

          protected static final String OP_RESET_LOGGING

      See Also:
        Constant Field Values

    - #### resetLoggingParams

          protected static final MBeanParameterInfo[] resetLoggingParams

    - #### OP_RESET_LOGGING_LEVEL

          protected static final MBeanOperationInfo OP_RESET_LOGGING_LEVEL

  - ### Constructor Detail

    - #### JEDiagnostics

          protected JEDiagnostics(Environment env)

    - #### JEDiagnostics

          public JEDiagnostics()

  - ### Method Detail

    - #### initClassFields

          protected void initClassFields()

      Specified by:
        `initClassFields` in class `JEMBean`

    - #### getAttribute

          public Object getAttribute(String attributeName)
                              throws AttributeNotFoundException,
                                     MBeanException

      Specified by:
        `getAttribute` in interface `DynamicMBean`
      Throws:
        `AttributeNotFoundException`
        `MBeanException`
      See Also:
        `DynamicMBean.getAttribute(java.lang.String)`

    - #### setAttribute

          public void setAttribute(Attribute attribute)
                            throws AttributeNotFoundException,
                                   InvalidAttributeValueException,
                                   MBeanException

      Specified by:
        `setAttribute` in interface `DynamicMBean`
      Throws:
        `AttributeNotFoundException`
        `InvalidAttributeValueException`
        `MBeanException`
      See Also:
        `DynamicMBean.setAttribute(javax.management.Attribute)`

    - #### getAttributes

          public AttributeList getAttributes(String[] attributes)

      Specified by:
        `getAttributes` in interface `DynamicMBean`
      See Also:
        `DynamicMBean.getAttributes(java.lang.String[])`

    - #### setAttributes

          public AttributeList setAttributes(AttributeList attributes)

      Specified by:
        `setAttributes` in interface `DynamicMBean`
      See Also:
        `DynamicMBean.setAttributes(javax.management.AttributeList)`

    - #### invoke

          public Object invoke(String actionName,
                      Object[] params,
                      String[] signature)
                        throws MBeanException

      Specified by:
        `invoke` in interface `DynamicMBean`
      Throws:
        `MBeanException`
      See Also:
        `DynamicMBean.invoke(java.lang.String, java.lang.Object[], java.lang.String[])`

    - #### doRegisterMBean

          protected void doRegisterMBean(Environment env)
                                  throws Exception

      Specified by:
        `doRegisterMBean` in class `JEMBean`
      Throws:
        `Exception`

    - #### getAttributeList

          protected MBeanAttributeInfo[] getAttributeList()

      Description copied from class: `JEMBean`
      Get attribute metadata for this MBean.
      Specified by:
        `getAttributeList` in class `JEMBean`
      Returns:
        array of MBeanAttributeInfo objects describing the available attributes.

    - #### addOperations

          protected void addOperations()

      Description copied from class: `JEMBean`
      Add MBean operations into the list.
      Specified by:
        `addOperations` in class `JEMBean`

Copyright (c) 2004, 2014 Oracle and/or its affiliates. All rights reserved.